
QGIS Application - Bug report #16544

Memory Layers do not seem to support the ExactIntersect flag for getFeatures(QgsMapRequest)

2017-05-12 04:56 PM - Georg Wicke

Status: Closed

Priority: Normal

Assignee:

Category: Virtual Layers

Affected QGIS version:2.18.5 Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution: end of life

Crashes QGIS or corrupts data:No Copied to github as #: 24450

Description

Steps to reproduce

1. Create a vector memory layer with some features

2. Try accessing getFeatures(QgsMapRequest) in Python:

request = QgsFeatureRequest(QgsRectangle(mapCoords, mapCoords)) # insert e. g. click coordinates here

request.setFlags(QgsFeatureRequest.ExactIntersect)

features = list(memoryLayer.getFeatures(request))

Observed behaviour

No feature is returned.

Expected behaviour

The features intersecting with the given point are returned.

Remarks

On layers loaded from disks, this works like a charm (you don't even need to supply the ExactIntersect flag).

An easy workaround is to not use exact feature requests, but just use normal ones and filtering manually with 

feature.geometry().contains(mapCoords)

Something similar could probably be the fix already.

Normal requests return all features which intersect with their bounding box.

See also #16068

Related issues:

Related to QGIS Application - Bug report # 16068: getFeatures() as well as sp... Closed 2017-01-12

History

#1 - 2017-05-19 08:58 AM - Jürgen Fischer

- Description updated

#2 - 2017-05-19 08:58 AM - Jürgen Fischer

- Related to Bug report #16068: getFeatures() as well as spartial indices are inaccurate with memory layers added
#3 - 2019-03-09 03:09 PM - Giovanni Manghi

- Resolution set to end of life

- Status changed from Open to Closed

End of life notice: QGIS 2.18 LTR

Source:

http://blog.qgis.org/2019/03/09/end-of-life-notice-qgis-2-18-ltr/

QGIS 3.4 has recently become our new Long Term Release  (LTR) version. This is a major step in our history – a long term release version based on the

massive updates, library upgrades and improvements that we carried out in the course of the 2.x to 3x upgrade cycle.

We strongly encourage all users who are currently using QGIS 2.18 LTR  as their preferred QGIS release to migrate to QGIS 3.4. This new LTR version

will receive regular bugfixes for at least one year. It also includes hundreds of new functions, usability improvements, bugfixes, and other goodies. See the

relevant changelogs for a good sampling of all the new features that have gone into version 3.4

Most plugins have been either migrated or incorporated into the core QGIS code base.

We strongly discourage the continued use of QGIS 2.18 LTR as it is now officially unsupported, which means we’ll not provide any bug fix releases for it.

You should also note that we intend to close all bug tickets referring to the now obsolete LTR version. Original reporters will receive a notification of the

ticket closure and are encouraged to check whether the issue persists in the new LTR, in which case they should reopen the ticket.

If you would like to better understand the QGIS release roadmap, check out our roadmap page! It outlines the schedule for upcoming releases and will help

you plan your deployment of QGIS into an operational environment.

The development of QGIS 3.4 LTR has been made possible by the work of hundreds of volunteers, by the investments of companies, professionals, and

administrations, and by continuous donations and financial support from many of you. We sincerely thank you all and encourage you to collaborate and

support the project even more, for the long term improvement and sustainability of the QGIS project.
